#define PCX

#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <io.h>

static char far *ra[480];
static long filebytes;
static int inited = 0;

void InitPCX(void)
{
#include "pcx21.c"
  inited = 1;
}

void encput(char outbyte, int rep_cnt, FILE *fp)
{
  char tmpchar;

  if (rep_cnt > 0)
  {
    if ((rep_cnt == 1) && (0xc0 != (0xc0 & outbyte)))
      putc(outbyte, fp);
    else
    {
      tmpchar = 0xc0 | rep_cnt;
      putc(tmpchar, fp);
      putc(outbyte, fp);
    }
  }
}

int SavePCX(char *filename)
{
  int row_cnt, byte_cnt, plane_cnt, rep_cnt;
  char last_byte, this_byte;
  char header_buf[128];
  int cnt, total_row_bytes, total_row_byte_cnt;
  FILE *fp;

  if (!inited)
    return 0;
  row_cnt = 0;
  byte_cnt = 0;
  plane_cnt = 0;

  for (cnt = 0; cnt < 128; ++cnt) header_buf[cnt] = 0;

  header_buf[0] = 10;
  header_buf[2] = 1;
  header_buf[1] = 3;

  header_buf[3] = 1;
  header_buf[65] = 4;
  header_buf[11] = 479 >> 8;
  header_buf[10] = 479 & 0xff;
  header_buf[9] = 639 >> 8;
  header_buf[8] = 639 & 0xff;
  header_buf[15] = 480 >> 8;
  header_buf[14] = 480 & 0xff;
  header_buf[13] = 640 >> 8;
  header_buf[12] = 640 & 0xff;
  header_buf[67] = 80 >> 8;
  header_buf[66] = 80 & 0xff;

  fp = fopen(filename, "wb");

  for (cnt = 0; cnt < 128; cnt++) putc(header_buf[cnt], fp);

  total_row_bytes = 320;

  for (row_cnt = 0; row_cnt < 480; row_cnt++)
  {
    byte_cnt = 0;
    plane_cnt = 0;
    outportb(0x3ce, 4);
    outportb(0x3cf, 0);
    last_byte = ra[row_cnt][byte_cnt];
    total_row_byte_cnt = 1;
    rep_cnt = 1;

    for (plane_cnt = 0; plane_cnt < 4; plane_cnt++)
    {
      outportb(0x3ce, 4);
      outportb(0x3cf, plane_cnt);
      for (byte_cnt = 0; byte_cnt < 80; byte_cnt++)
      {
        if (total_row_byte_cnt == 1)
        {
          total_row_byte_cnt++;
          goto end_of_byte_fetch;
        }
        else
          total_row_byte_cnt++;
	this_byte = ra[row_cnt][byte_cnt];
        if (last_byte == this_byte)
          rep_cnt++;
        else
        {
          encput(last_byte, rep_cnt, fp);
          rep_cnt = 1;
          if (total_row_byte_cnt > total_row_bytes)
          {
            encput(this_byte, rep_cnt, fp);
            goto end_of_byte_fetch;
          }
        }
        if (rep_cnt == 63)
        {
          encput(last_byte, rep_cnt, fp);
          rep_cnt = 0;
        }
        if (total_row_byte_cnt > total_row_bytes)
        {
          encput(last_byte, rep_cnt, fp);
          rep_cnt = 0;
        }
        last_byte = this_byte;
        end_of_byte_fetch:
        ;
      }
    }
  }
  outportb(0x3cf, 0);
  fclose(fp);
  return 1;
}

void encget(char *inbyte, int *reps, FILE *fp)
{
  char data;

  *reps = 1;
  data = getc(fp);
  filebytes--;
  if (0xc0 == (0xc0 & data))
  {
    *reps = 0x3f & data;
    data = getc(fp);
    filebytes--;
  }
  *inbyte = data;
}

int LoadPCX(char *filename)
{
  int row_cnt, byte_cnt, plane_cnt, bytes_per_line;
  int reps, cnt;
  char data;
  char header_buf[128];
  FILE *fp;

  int ega_plane_map[4] = {1,2,4,8};
  #define NPLANES 65

  if (!inited)
    return 0;
  row_cnt = 0;
  byte_cnt = 0;
  plane_cnt = 0;

  fp = fopen(filename, "rb");
  filebytes = filelength(fileno(fp));

  for (cnt = 0; cnt < 128; cnt++)
  {
    filebytes--;
    header_buf[cnt] = getc(fp);
  }

  bytes_per_line = ((header_buf[67]) >> 8) | header_buf[66];

  outportb(0x3c4, 2);
  outportb(0x3c5, ega_plane_map[plane_cnt]);

  while (filebytes)
  {
    encget(&data, &reps, fp);
    while (reps--)
    {
      ra[row_cnt][byte_cnt++] = data;
      if (byte_cnt >= bytes_per_line)
      {
        byte_cnt = 0;
        plane_cnt++;
        if (plane_cnt < header_buf[NPLANES])
        {
          outportb(0x3c4, 2);
          outportb(0x3c5, ega_plane_map[plane_cnt]);
        }
        else
        {
          plane_cnt = 0;
          outportb(0x3c4, 2);
          outportb(0x3c5, ega_plane_map[plane_cnt]);
          row_cnt++;
        }
      }
    }
  }
  outportb(0x3c4, 0x2);
  outportb(0x3c5, 0xf);
  fclose(fp);
  return 1;
}

